<?php
/**
 * This file is part of TheCartPress-csvloader.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * NOTICES
 * -------
 * Since TCP 1.0.9: the tax should be an index, not the real tax rate.
 */
if ( ! session_id() ) session_start();
$post_type	= isset( $_REQUEST['post_type'] ) ? $_REQUEST['post_type'] : 'tcp_product';
$separator	= isset( $_REQUEST['separator'] ) ? $_REQUEST['separator'] : ',';
//$enclosure	= isset( $_REQUEST['enclosure'] ) ? $_REQUEST['enclosure'] : '"';
$titeled	= isset( $_REQUEST['titeled'] );
$taxonomy	= isset( $_REQUEST['taxonomy'] ) ? $_REQUEST['taxonomy'] : 'tcp_product_category';
$cat		= isset( $_REQUEST['tcp_cat'] ) ? $_REQUEST['tcp_cat'] : '';
$tcp_status	= isset( $_REQUEST['tcp_status'] ) ? $_REQUEST['tcp_status'] : '';
$data		= array();
$titles		= array();

if ( isset( $_REQUEST['tcp_load_csv'] ) && isset( $_FILES['upload_file'] ) && strlen( $_FILES['upload_file']['tmp_name'] ) > 0 ) {
	if ( ( $handle = fopen( $_FILES['upload_file']['tmp_name'], 'r' ) ) !== FALSE ) {
		while ( ( $line = fgetcsv( $handle, 10240, $separator ) ) !== FALSE ) {
			$data[] = $line;
		}
		fclose( $handle );
		if ( $titeled ) {
			$titles = $data[0];
			unset( $data[0] );
		} else {
			for( $i = 0; $i < count( $data[0] ); $i++ )
				$titles[] = 'col_' . $i;
		}
	}
	$_SESSION['tcp_csv_titles'] = $titles;
	$_SESSION['tcp_csv_data'] = $data;
} elseif ( isset( $_REQUEST['tcp_load_products_from_csv'] ) && isset( $_SESSION['tcp_csv_titles'] ) ) {
	$titles = $_SESSION['tcp_csv_titles'];
	$data = $_SESSION['tcp_csv_data'];
	unset( $_SESSION['tcp_csv_titles'] );
	unset( $_SESSION['tcp_csv_data'] );
	if ( is_array( $data ) ) {
		$custom_field_defs = tcp_get_custom_fields_def( $post_type );
		$taxonomies = get_object_taxonomies( $post_type );
		$count = 0;
		$i = 0;
		foreach( $data as $cols ) {
			$i++;
			$name = '';
			$content = '';
			$excerpt = '';
			$price = 0;
			$order = '';
			$weight = 0;
			$sku = '';
			$stock = -1;
			$tax = 0;
			$upload = '';
			$attachments = array();
			$thumbnail = '';
			$custom_values = array();
			$taxo_values = array();
			foreach( $cols as $i => $col ) {
				$col_names = isset( $_REQUEST['col_' . $i] ) ? $_REQUEST['col_' . $i] : array();
				if ( is_array( $col_names ) && count( $col_names ) > 0 ) {
					foreach( $col_names as $col_name ) {
						if ( 'tcp_name' == $col_name ) {
							$name = $col;//string
						}
						if ( 'tcp_content' == $col_name ) {
							$content = $col;//string
						}
						if ( 'tcp_excerpt' == $col_name ) {
							$excerpt = $col;//string
						}
						if ( 'tcp_price' == $col_name ) {
							$price = tcp_csv_getPrice( $col );
						}
						if ( 'tcp_order' == $col_name ) {
							$order = $col;//string
						}
						if ( 'tcp_weight' == $col_name ) {
							$weight = (float)$col;
						}
						if ( 'tcp_sku' == $col_name ) {
							$sku = $col;
						}
						if ( 'tcp_stock' == $col_name ) {
							$stock = (int)$col;
						}
						if ( 'tcp_tax' == $col_name ) {
							$tax = (int)$col;
						}
						if ( 'tcp_upload' == $col_name ) {
							$upload = $col;//path
						}
						if ( 'tcp_attachment' == $col_name ) {
							$attachments[] = $col;//url
						}
						if ( 'tcp_thumbnail' == $col_name ) {
							$thumbnail = $col;//url
						}
						if ( is_array( $custom_field_defs ) && count( $custom_field_defs ) > 0 ) {
							foreach( $custom_field_defs as $custom_field_def ) {
								if ( $col_name == $custom_field_def['id'] ) {
									$custom_values[$col_name] = $col;
									break;
								}
							}
						}
						if ( is_array( $taxonomies ) && count( $taxonomies ) > 0 ) {
							foreach( $taxonomies as $taxmy ) {
								if ( $col_name == 'tcp_tax_' . $taxmy ) {
									$taxo_values[$taxmy] = explode( ',', $col );
									break;
								}
							}
						}
					}
				}
			}
			$post = array(
				'comment_status'=> 'closed',
				'post_content'	=> $content,
				'post_excerpt'	=> $excerpt,
				'post_status'	=> $tcp_status,
				'post_title'	=> $name,
				'post_type'		=> $post_type,
			);
			$post = apply_filters( 'tcp_csv_loader_new_post', $post, $cols );
			$post_id = false;
			if ( strlen( $sku ) > 0 ) {
				$post_id = tcp_get_product_by_sku( $sku );
				$post_id = tcp_get_default_id( $post_id, get_post_type( $post_id ) );
			}
			if ( $post_id !== false ) $post['ID'] = $post_id;
			$post_id = wp_insert_post( $post, true );
			if ( is_wp_error( $post_id ) ) die( $post_id->get_error_message() );
			if ( $cat > 0 ) wp_set_object_terms( $post_id, (int)$cat, $taxonomy, false );
			update_post_meta( $post_id, 'tcp_tax_id', $tax );
			update_post_meta( $post_id, 'tcp_is_visible', true );
			update_post_meta( $post_id, 'tcp_is_downloadable', false );
			update_post_meta( $post_id, 'tcp_max_downloads', 0 );
			update_post_meta( $post_id, 'tcp_days_to_expire', 0 );
			update_post_meta( $post_id, 'tcp_type', 'SIMPLE' );
			update_post_meta( $post_id, 'tcp_price', $price );
			update_post_meta( $post_id, 'tcp_weight', $weight );
			update_post_meta( $post_id, 'tcp_order', $order );
			update_post_meta( $post_id, 'tcp_sku', $sku );
			update_post_meta( $post_id, 'tcp_stock', $stock );
			foreach( $custom_values as $id => $custom_value ) {
				$custom_value = apply_filters( 'tcp_csv_loader_custom_value', $custom_value, $post_id, $cols );
				update_post_meta( $post_id, $id, $custom_value );
			}
			foreach( $taxo_values as $tax => $terms ) {
				if ( is_array( $terms ) && count( $terms ) > 0 ) {
					foreach( $terms as $term ) {
						$new_term = term_exists( $term, $tax );
						if ( ! is_array( $new_term ) ) {
							$term = apply_filters( 'tcp_csv_loader_term', $term, $post_id, $cols );
							$new_term = wp_insert_term(	$term, $tax, array( 'slug' => esc_html( $term ) ) );
							//$new_term = wp_insert_term(	$term, $tax, array( 'slug' => 'tcp_' . $term ) );
						}
						if ( is_array( $new_term ) ) {
							wp_set_object_terms( $post_id, (int)$new_term['term_id'], $tax, true );
						}// else empty
					}
				}
			}
			if ( strlen( $upload )  > 0 ) {
				update_post_meta( $post_id, 'tcp_is_downloadable', true );
				update_post_meta( $post_id, 'tcp_max_downloads', -1 );
				update_post_meta( $post_id, 'tcp_days_to_expire', -1 );
				$upload = apply_filters( 'tcp_csv_loader_upload_url', $upload, $post_id, $cols );
				tcp_set_the_file( $post_id, $upload );
			}
			foreach( $attachments as $url ) {
				$base = basename( $url );
				$path = wp_upload_dir();
				$path = $path['path'];
				$dest = $path . '/' . $base;
				copy( apply_filters( 'tcp_csv_loader_attachment_url', $url, $post_id, $cols ), $dest );
				$wp_filetype = wp_check_filetype( basename( $dest ), null );
				$attachment = array(
					'post_mime_type'	=> $wp_filetype['type'],
					'post_title'		=> preg_replace( '/\.[^.]+$/', '', basename( $dest ) ),
					'post_content'		=> '',
					'post_status'		=> 'inherit',
					'post_parent'		=> $post_id,
				);
				$attach_id = wp_insert_attachment( $attachment, $dest, $post_id );
				require_once( ABSPATH . 'wp-admin/includes/image.php' );
				$attach_data = wp_generate_attachment_metadata( $attach_id, $dest );
				wp_update_attachment_metadata( $attach_id,  $attach_data );
			}
			if ( strlen( $thumbnail ) > 0 ) {
				$base = basename( $thumbnail );
				$path = wp_upload_dir();
				$path = $path['path'];
				$dest = $path . '/' . $base;
				copy( apply_filters( 'tcp_csv_loader_attachment_url', $thumbnail, $post_id, $cols ), $dest );
				$wp_filetype = wp_check_filetype( basename( $dest ), null );
				$attachment = array(
					'post_mime_type'	=> $wp_filetype['type'],
					'post_title'		=> preg_replace( '/\.[^.]+$/', '', basename( $dest ) ),
					'post_content'		=> '',
					'post_status'		=> 'inherit',
					'post_parent' 		=> $post_id,
				);
				$attach_id = wp_insert_attachment( $attachment, $dest, $post_id );
				// you must first include the image.php file for the function wp_generate_attachment_metadata() to work
				require_once( ABSPATH . 'wp-admin/includes/image.php' );
				$attach_data = wp_generate_attachment_metadata( $attach_id, $dest );
				wp_update_attachment_metadata( $attach_id,  $attach_data );
				update_post_meta( $post_id, '_thumbnail_id', $attach_id );
			}
			do_action( 'tcp_csv_loader_row', $post_id, $cols );
			$count++;
		}
		?>
		<div id="message" class="updated"><p>
			<?php printf( __( '%s products have been uploaded', 'tcp_csvl' ), $count ); ?>
		</p></div><?php
	} else {?>
		<div id="message" class="error"><p>
			<?php _e( 'No product has been uploaded', 'tcp_csvl' ); ?>
		</p></div><?php
	}
} elseif ( isset( $_REQUEST['tcp_load_csv'] ) && isset( $_FILES['upload_file'] ) && strlen( $_FILES['upload_file']['tmp_name'] ) == 0 ) { ?>
<div id="message" class="error"><p>
	<?php _e( 'File cannot be empty', 'tcp_csvl' ); ?>
</p></div>
<?php } ?>
<div class="wrap">

<h2><?php _e( 'CSV Loader', 'tcp_csvl' ); ?></h2>
<ul class="subsubsub">
</ul><!-- subsubsub -->

<div class="clear"></div>

<form method="post" enctype="multipart/form-data">
	<table class="form-table">
	<tbody>
	<tr valign="top">
	<th scope="row">
		<label for="post_type"><?php _e( 'Post type', 'tcp_csvl' )?>:</label>
	</th>
	<td>
		<select name="post_type" id="post_type">
		<?php foreach( tcp_get_saleable_post_types() as $pt ) : $obj = get_post_type_object( $pt ); var_dump( $obj );?>
			<option value="<?php echo $pt; ?>"<?php selected( $post_type, $pt ); ?>><?php echo $obj->labels->name; ?></option>
		<?php endforeach; ?>
		</select>
		<input type="submit" name="tcp_load_taxonomies" value="<?php _e( 'Load taxonomies', 'tcp_csvl' ); ?>" class="button-secondary"/>
		<p class="description"><?php _e( 'Select what type of saleable post type do you want to use, usually, Products', 'tcp_csvl' ); ?></p>
	</td>
	</tr>
	<tr valign="top">
	<th scope="row">
		<label for="taxonomy"><?php _e( 'Taxonomy', 'tcp_csvl' )?>:</label>
	</th>
	<td>
		<select name="taxonomy" id="taxonomy">
		<?php foreach( get_object_taxonomies( $post_type ) as $taxmy ) : $tax = get_taxonomy( $taxmy ); ?>
			<option value="<?php echo esc_attr( $taxmy ); ?>"<?php selected( $taxmy, $taxonomy ); ?>><?php echo $tax->labels->name; ?></option>
		<?php endforeach; ?>
		</select>
		<p class="description"><?php _e( 'Select the type of taxonomy you want to use. Usually, select Categories (of products).', 'tcp_csvl' ); ?></p>
		<p class="description"><?php _e( 'This action allows to select, later, the category term where to assign all the products.', 'tcp_csvl' ); ?></p>
		<p class="description"><?php _e( 'However, each product could be assigned to different terms if one of the columns, in the CSV file, is used to assign them.', 'tcp_csvl' ); ?></p>
	</td>
	</tr>
	<tr valign="top">
	<th scope="row">
		<label for="separator"><?php _e( 'Separator', 'tcp_csvl' ); ?>:</label>
	</th>
	<td>
		<input type="text" name="separator" id="separator" value="<?php echo $separator; ?>" size="2" maxlength="1"/>
		<label for="titeled"><?php _e( 'Column titles in the first line', 'tcp_csvl' ); ?>:</label>
		<input type="checkbox" name="titeled" id="titeled" <?php checked( $titeled ); ?> />
		<p class="description"><?php _e( 'These fields are used to define the format of the csv.', 'tcp_csvl' ); ?></p>
		<p class="description"><?php _e( 'The Separator, usually, is a comma or the vertical slash "|". If the CSV has column titles in the first line, set the field "Column titles in the first line".', 'tcp_csvl' ); ?></p>
	</td>
	</tr>
	<tr valign="top">
	<th scope="row">
		<label for="upload_file" value=""><?php _e( 'file', 'tcp_csvl' ); ?>:</label>
	</th>
	<td>
		<input type="file" name="upload_file" id="upload_file" />
	</td>
	</tr>
	</tbody>
	</table>
	<span class="submit"><input type="submit" name="tcp_load_csv" id="tcp_load_csv" value="<?php _e( 'Load', 'tcp_csvl' ); ?>" style="button-secondary" /></span>
	<span class="description"><?php _e( 'This action helps to you to test if the file is right. Only the first four rows will be displayed.', 'tcp_csvl' ); ?></span>
</form>

<?php if ( is_array( $data ) && count( $data ) > 0 ) : ?>
<p><?php _e( 'These lines are the first four products loaded from the CSV file. If you think they are correct continue with the process.', 'tcp_csvl' ); ?></p>
<table class="widefat fixed" cellspacing="0">
	<?php if ( is_array( $titles ) && count( $titles ) > 0 ) : ?>
		<thead>
		<tr scope="col" class="manage-column"><th>&nbsp;</th>
		<?php foreach( $titles as $col ) : ?>
			<th><?php echo $col; ?></th>
		<?php endforeach; ?>
		</tr>
		</thead>
		<tfoot>
		<tr scope="col" class="manage-column"><th>&nbsp;</th>
		<?php foreach( $titles as $col ) : ?>
			<th><?php echo $col; ?></th>
		<?php endforeach; ?>
		</tr>
		</tfoot>
	<?php endif; ?>
		<tbody>
		<?php foreach( $data as $i => $cols ) :
			if ( $i > 4 ) :
				break;
			else : ?>
				<tr>
					<td><?php echo $i; ?></td>
				<?php foreach( $cols as $col ) : ?>
					<td><?php echo $col; ?></td>
				<?php endforeach; ?>
				</tr>
			<?php endif; ?>
		<?php endforeach; ?>
	</tbody>
</table>
<p><?php _e( 'Assign the columns of the CSV file (left column) to the fields of the products (right column).', 'tcp_csvl' ); ?></p>
<form method="post">
<input type="hidden" name="post_type" value="<?php echo $post_type; ?>" />
<input type="hidden" name="taxonomy" value="<?php echo $taxonomy; ?>" />
<input type="hidden" name="separator" value="<?php echo isset( $_REQUEST['separator'] ) ? $_REQUEST['separator'] : ','; ?>" />
<?php if ( isset( $_REQUEST['titeled'] ) ) :?>
<input type="hidden" name="titeled" value="y"/>
<?php endif; ?>
<table class="widefat fixed" cellspacing="0">
<thead>
	<tr scope="col" class="manage-column">
		<th><?php _e( 'Imported columns', 'tcp_csvl' ); ?></th>
		<th><?php _e( 'TheCartPress columns', 'tcp_csvl' ); ?></th>
	</tr>
</thead>
<tfoot>
	<tr scope="col" class="manage-column">
		<th><?php _e( 'CSV columns', 'tcp_csvl' ); ?></th>
		<th><?php _e( 'TheCartPress columns', 'tcp_csvl' ); ?></th>
	</tr>
</tfoot>
<tbody>
<?php if ( is_array( $titles ) && count( $titles ) > 0 ) : ?>
	<?php foreach( $titles as $i => $col ) : ?>
		<tr>
			<td><?php echo $col; ?></td>
			<td>
			<select name="col_<?php echo $i; ?>[]" multiple="true" size="4" style="height: auto;">
				<option value=""><?php _e( 'None', 'tcp_csvl' ); ?></option>
				<option value="tcp_name" <?php selected( strtoupper( $col ), 'TITLE'); ?>>Title (<?php _e( 'Title', 'tcp_csvl' ); ?>)</option>
				<option value="tcp_content" <?php selected( strtoupper( $col ), 'CONTENT'); ?>>Content (<?php _e( 'Content', 'tcp_csvl' ); ?>)</option>
				<option value="tcp_excerpt" <?php selected( strtoupper( $col ), 'EXCERPT'); ?>>Excerpt (<?php _e( 'Excerpt', 'tcp_csvl' ); ?>)</option>
				<option value="tcp_price" <?php selected( strtoupper( $col ), 'PRICE'); ?>>Price (<?php _e( 'Price', 'tcp_csvl' ); ?>)</option>
				<option value="tcp_stock" <?php selected( strtoupper( $col ), 'STOCK'); ?>>Stock (<?php _e( 'Stock', 'tcp_csvl' ); ?>)</option>
				<option value="tcp_weight" <?php selected( strtoupper( $col ), 'WEIGHT'); ?>>Weight (<?php _e( 'Weight', 'tcp_csvl' ); ?>)</option>
				<option value="tcp_sku" <?php selected( strtoupper( $col ), 'SKU'); ?>>SKU (<?php _e( 'SKU', 'tcp_csvl' ); ?>)</option>
				<option value="tcp_order" <?php selected( strtoupper( $col ), 'ORDER'); ?>>Order (<?php _e( 'Order', 'tcp_csvl' ); ?>)</option>
				<option value="tcp_tax" <?php selected( strtoupper( $col ), 'TAX'); ?>>Tax (<?php _e( 'Tax', 'tcp_csvl' ); ?>)</option>
				<option value="tcp_upload" <?php selected( strtoupper( $col ), 'UPLOAD'); ?>>Upload (<?php _e( 'Upload', 'tcp_csvl' ); ?>)</option>
				<option value="tcp_attachment" <?php selected( strtoupper( $col ), 'ATTACHMENT'); ?>>Attachment (<?php _e( 'Attachment', 'tcp_csvl' ); ?>)</option>
				<option value="tcp_thumbnail" <?php selected( strtoupper( $col ), 'THUMBNAIL'); ?>>Thumbnail (<?php _e( 'Thumbnail', 'tcp_csvl' ); ?>)</option>
				<?php $custom_fields_def = tcp_get_custom_fields_def( $post_type );
				if ( is_array( $custom_fields_def ) && count( $custom_fields_def ) > 0 ) :
					foreach( $custom_fields_def as $custom_field_def ) : ?>
				<option value="<?php echo $custom_field_def['id']; ?>" <?php selected( $col, $custom_field_def['label'] ); ?>>Custom Fields: <?php echo $custom_field_def['label']; ?></option>
					<?php endforeach;
				endif?>
				<?php foreach( get_object_taxonomies( $post_type ) as $taxmy ) : $tax = get_taxonomy( $taxmy ); ?>
				<option value="tcp_tax_<?php echo $taxmy; ?>" <?php selected( $col, $tax->labels->name ); ?>>Taxonomy: <?php echo $tax->labels->name; ?></option>
				<?php endforeach; ?>
			</select>
			</td>
		</tr>
	<?php endforeach; ?>
<?php endif; ?>
</tbody>
</table>
<p>
	<label for="tcp_cat"><?php _e( 'Attach this products to the Taxonomy', 'tcp_csvl' )?>:</label>
	<select id="tcp_cat" name="tcp_cat">
		<option value=""><?php _e( 'No one', 'tcp_csvl' ); ?></option>
	<?php $terms = get_terms( $taxonomy, array( 'hide_empty' => false ) );
	if ( is_array( $terms ) && count( $terms ) ) foreach( $terms as $term ) : ?>
		<option value="<?php echo $term->term_id; ?>"<?php selected( $term->term_id, $cat ); ?>><?php echo esc_attr( $term->name ); ?></option>
	<?php endforeach; ?>
	</select>
</p>
<p>
	<label for="tcp_status"><?php _e( 'Set new products status to', 'tcp_csvl' )?>:</label>
	<select id="tcp_post_status" name="tcp_status">
		<option value="publish"><?php _e( 'publish', 'tcp_cvsl' ); ?></option>
		<option value="draft"><?php _e( 'draft', 'tcp_cvsl' ); ?></option>
	</select>
</p>
<span class="submit">
	<input type="submit" name="tcp_load_products_from_csv" id="tcp_load_products_from_csv" value="<?php _e( 'Upload', 'tcp_csvl' ); ?>" class="button-primary" />
	<span><?php _e( 'This action will load the products in the eCommerce. Be patient.', 'tcp_csvl' ); ?></span>
</span>
</form>
<?php endif; ?>
</div>
<?php
function tcp_csv_getPrice( $source ) {
	$aux = str_replace( '$', '', $source );
	return tcp_input_number( $aux );
}
?>